package com.yutou.bilibili.mybatis.Bili.mybatis.model;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class BilibiliLiveDataExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public BilibiliLiveDataExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andUidIsNull() {
            addCriterion("`uid` is null");
            return (Criteria) this;
        }

        public Criteria andUidIsNotNull() {
            addCriterion("`uid` is not null");
            return (Criteria) this;
        }

        public Criteria andUidEqualTo(Integer value) {
            addCriterion("`uid` =", value, "uid");
            return (Criteria) this;
        }

        public Criteria andUidNotEqualTo(Integer value) {
            addCriterion("`uid` <>", value, "uid");
            return (Criteria) this;
        }

        public Criteria andUidGreaterThan(Integer value) {
            addCriterion("`uid` >", value, "uid");
            return (Criteria) this;
        }

        public Criteria andUidGreaterThanOrEqualTo(Integer value) {
            addCriterion("`uid` >=", value, "uid");
            return (Criteria) this;
        }

        public Criteria andUidLessThan(Integer value) {
            addCriterion("`uid` <", value, "uid");
            return (Criteria) this;
        }

        public Criteria andUidLessThanOrEqualTo(Integer value) {
            addCriterion("`uid` <=", value, "uid");
            return (Criteria) this;
        }

        public Criteria andUidIn(List<Integer> values) {
            addCriterion("`uid` in", values, "uid");
            return (Criteria) this;
        }

        public Criteria andUidNotIn(List<Integer> values) {
            addCriterion("`uid` not in", values, "uid");
            return (Criteria) this;
        }

        public Criteria andUidBetween(Integer value1, Integer value2) {
            addCriterion("`uid` between", value1, value2, "uid");
            return (Criteria) this;
        }

        public Criteria andUidNotBetween(Integer value1, Integer value2) {
            addCriterion("`uid` not between", value1, value2, "uid");
            return (Criteria) this;
        }

        public Criteria andRoomidIsNull() {
            addCriterion("roomid is null");
            return (Criteria) this;
        }

        public Criteria andRoomidIsNotNull() {
            addCriterion("roomid is not null");
            return (Criteria) this;
        }

        public Criteria andRoomidEqualTo(Integer value) {
            addCriterion("roomid =", value, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidNotEqualTo(Integer value) {
            addCriterion("roomid <>", value, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidGreaterThan(Integer value) {
            addCriterion("roomid >", value, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidGreaterThanOrEqualTo(Integer value) {
            addCriterion("roomid >=", value, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidLessThan(Integer value) {
            addCriterion("roomid <", value, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidLessThanOrEqualTo(Integer value) {
            addCriterion("roomid <=", value, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidIn(List<Integer> values) {
            addCriterion("roomid in", values, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidNotIn(List<Integer> values) {
            addCriterion("roomid not in", values, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidBetween(Integer value1, Integer value2) {
            addCriterion("roomid between", value1, value2, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidNotBetween(Integer value1, Integer value2) {
            addCriterion("roomid not between", value1, value2, "roomid");
            return (Criteria) this;
        }

        public Criteria andTypeIsNull() {
            addCriterion("`type` is null");
            return (Criteria) this;
        }

        public Criteria andTypeIsNotNull() {
            addCriterion("`type` is not null");
            return (Criteria) this;
        }

        public Criteria andTypeEqualTo(String value) {
            addCriterion("`type` =", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotEqualTo(String value) {
            addCriterion("`type` <>", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeGreaterThan(String value) {
            addCriterion("`type` >", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeGreaterThanOrEqualTo(String value) {
            addCriterion("`type` >=", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeLessThan(String value) {
            addCriterion("`type` <", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeLessThanOrEqualTo(String value) {
            addCriterion("`type` <=", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeLike(String value) {
            addCriterion("`type` like", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotLike(String value) {
            addCriterion("`type` not like", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeIn(List<String> values) {
            addCriterion("`type` in", values, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotIn(List<String> values) {
            addCriterion("`type` not in", values, "type");
            return (Criteria) this;
        }

        public Criteria andTypeBetween(String value1, String value2) {
            addCriterion("`type` between", value1, value2, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotBetween(String value1, String value2) {
            addCriterion("`type` not between", value1, value2, "type");
            return (Criteria) this;
        }

        public Criteria andMsgIsNull() {
            addCriterion("msg is null");
            return (Criteria) this;
        }

        public Criteria andMsgIsNotNull() {
            addCriterion("msg is not null");
            return (Criteria) this;
        }

        public Criteria andMsgEqualTo(String value) {
            addCriterion("msg =", value, "msg");
            return (Criteria) this;
        }

        public Criteria andMsgNotEqualTo(String value) {
            addCriterion("msg <>", value, "msg");
            return (Criteria) this;
        }

        public Criteria andMsgGreaterThan(String value) {
            addCriterion("msg >", value, "msg");
            return (Criteria) this;
        }

        public Criteria andMsgGreaterThanOrEqualTo(String value) {
            addCriterion("msg >=", value, "msg");
            return (Criteria) this;
        }

        public Criteria andMsgLessThan(String value) {
            addCriterion("msg <", value, "msg");
            return (Criteria) this;
        }

        public Criteria andMsgLessThanOrEqualTo(String value) {
            addCriterion("msg <=", value, "msg");
            return (Criteria) this;
        }

        public Criteria andMsgLike(String value) {
            addCriterion("msg like", value, "msg");
            return (Criteria) this;
        }

        public Criteria andMsgNotLike(String value) {
            addCriterion("msg not like", value, "msg");
            return (Criteria) this;
        }

        public Criteria andMsgIn(List<String> values) {
            addCriterion("msg in", values, "msg");
            return (Criteria) this;
        }

        public Criteria andMsgNotIn(List<String> values) {
            addCriterion("msg not in", values, "msg");
            return (Criteria) this;
        }

        public Criteria andMsgBetween(String value1, String value2) {
            addCriterion("msg between", value1, value2, "msg");
            return (Criteria) this;
        }

        public Criteria andMsgNotBetween(String value1, String value2) {
            addCriterion("msg not between", value1, value2, "msg");
            return (Criteria) this;
        }

        public Criteria andGiftidIsNull() {
            addCriterion("giftId is null");
            return (Criteria) this;
        }

        public Criteria andGiftidIsNotNull() {
            addCriterion("giftId is not null");
            return (Criteria) this;
        }

        public Criteria andGiftidEqualTo(Integer value) {
            addCriterion("giftId =", value, "giftid");
            return (Criteria) this;
        }

        public Criteria andGiftidNotEqualTo(Integer value) {
            addCriterion("giftId <>", value, "giftid");
            return (Criteria) this;
        }

        public Criteria andGiftidGreaterThan(Integer value) {
            addCriterion("giftId >", value, "giftid");
            return (Criteria) this;
        }

        public Criteria andGiftidGreaterThanOrEqualTo(Integer value) {
            addCriterion("giftId >=", value, "giftid");
            return (Criteria) this;
        }

        public Criteria andGiftidLessThan(Integer value) {
            addCriterion("giftId <", value, "giftid");
            return (Criteria) this;
        }

        public Criteria andGiftidLessThanOrEqualTo(Integer value) {
            addCriterion("giftId <=", value, "giftid");
            return (Criteria) this;
        }

        public Criteria andGiftidIn(List<Integer> values) {
            addCriterion("giftId in", values, "giftid");
            return (Criteria) this;
        }

        public Criteria andGiftidNotIn(List<Integer> values) {
            addCriterion("giftId not in", values, "giftid");
            return (Criteria) this;
        }

        public Criteria andGiftidBetween(Integer value1, Integer value2) {
            addCriterion("giftId between", value1, value2, "giftid");
            return (Criteria) this;
        }

        public Criteria andGiftidNotBetween(Integer value1, Integer value2) {
            addCriterion("giftId not between", value1, value2, "giftid");
            return (Criteria) this;
        }

        public Criteria andGiftnameIsNull() {
            addCriterion("giftName is null");
            return (Criteria) this;
        }

        public Criteria andGiftnameIsNotNull() {
            addCriterion("giftName is not null");
            return (Criteria) this;
        }

        public Criteria andGiftnameEqualTo(String value) {
            addCriterion("giftName =", value, "giftname");
            return (Criteria) this;
        }

        public Criteria andGiftnameNotEqualTo(String value) {
            addCriterion("giftName <>", value, "giftname");
            return (Criteria) this;
        }

        public Criteria andGiftnameGreaterThan(String value) {
            addCriterion("giftName >", value, "giftname");
            return (Criteria) this;
        }

        public Criteria andGiftnameGreaterThanOrEqualTo(String value) {
            addCriterion("giftName >=", value, "giftname");
            return (Criteria) this;
        }

        public Criteria andGiftnameLessThan(String value) {
            addCriterion("giftName <", value, "giftname");
            return (Criteria) this;
        }

        public Criteria andGiftnameLessThanOrEqualTo(String value) {
            addCriterion("giftName <=", value, "giftname");
            return (Criteria) this;
        }

        public Criteria andGiftnameLike(String value) {
            addCriterion("giftName like", value, "giftname");
            return (Criteria) this;
        }

        public Criteria andGiftnameNotLike(String value) {
            addCriterion("giftName not like", value, "giftname");
            return (Criteria) this;
        }

        public Criteria andGiftnameIn(List<String> values) {
            addCriterion("giftName in", values, "giftname");
            return (Criteria) this;
        }

        public Criteria andGiftnameNotIn(List<String> values) {
            addCriterion("giftName not in", values, "giftname");
            return (Criteria) this;
        }

        public Criteria andGiftnameBetween(String value1, String value2) {
            addCriterion("giftName between", value1, value2, "giftname");
            return (Criteria) this;
        }

        public Criteria andGiftnameNotBetween(String value1, String value2) {
            addCriterion("giftName not between", value1, value2, "giftname");
            return (Criteria) this;
        }

        public Criteria andGiftindexIsNull() {
            addCriterion("giftIndex is null");
            return (Criteria) this;
        }

        public Criteria andGiftindexIsNotNull() {
            addCriterion("giftIndex is not null");
            return (Criteria) this;
        }

        public Criteria andGiftindexEqualTo(Integer value) {
            addCriterion("giftIndex =", value, "giftindex");
            return (Criteria) this;
        }

        public Criteria andGiftindexNotEqualTo(Integer value) {
            addCriterion("giftIndex <>", value, "giftindex");
            return (Criteria) this;
        }

        public Criteria andGiftindexGreaterThan(Integer value) {
            addCriterion("giftIndex >", value, "giftindex");
            return (Criteria) this;
        }

        public Criteria andGiftindexGreaterThanOrEqualTo(Integer value) {
            addCriterion("giftIndex >=", value, "giftindex");
            return (Criteria) this;
        }

        public Criteria andGiftindexLessThan(Integer value) {
            addCriterion("giftIndex <", value, "giftindex");
            return (Criteria) this;
        }

        public Criteria andGiftindexLessThanOrEqualTo(Integer value) {
            addCriterion("giftIndex <=", value, "giftindex");
            return (Criteria) this;
        }

        public Criteria andGiftindexIn(List<Integer> values) {
            addCriterion("giftIndex in", values, "giftindex");
            return (Criteria) this;
        }

        public Criteria andGiftindexNotIn(List<Integer> values) {
            addCriterion("giftIndex not in", values, "giftindex");
            return (Criteria) this;
        }

        public Criteria andGiftindexBetween(Integer value1, Integer value2) {
            addCriterion("giftIndex between", value1, value2, "giftindex");
            return (Criteria) this;
        }

        public Criteria andGiftindexNotBetween(Integer value1, Integer value2) {
            addCriterion("giftIndex not between", value1, value2, "giftindex");
            return (Criteria) this;
        }

        public Criteria andPriceIsNull() {
            addCriterion("price is null");
            return (Criteria) this;
        }

        public Criteria andPriceIsNotNull() {
            addCriterion("price is not null");
            return (Criteria) this;
        }

        public Criteria andPriceEqualTo(Integer value) {
            addCriterion("price =", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceNotEqualTo(Integer value) {
            addCriterion("price <>", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceGreaterThan(Integer value) {
            addCriterion("price >", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceGreaterThanOrEqualTo(Integer value) {
            addCriterion("price >=", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceLessThan(Integer value) {
            addCriterion("price <", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceLessThanOrEqualTo(Integer value) {
            addCriterion("price <=", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceIn(List<Integer> values) {
            addCriterion("price in", values, "price");
            return (Criteria) this;
        }

        public Criteria andPriceNotIn(List<Integer> values) {
            addCriterion("price not in", values, "price");
            return (Criteria) this;
        }

        public Criteria andPriceBetween(Integer value1, Integer value2) {
            addCriterion("price between", value1, value2, "price");
            return (Criteria) this;
        }

        public Criteria andPriceNotBetween(Integer value1, Integer value2) {
            addCriterion("price not between", value1, value2, "price");
            return (Criteria) this;
        }

        public Criteria andPriceofcommissionIsNull() {
            addCriterion("priceOfcommission is null");
            return (Criteria) this;
        }

        public Criteria andPriceofcommissionIsNotNull() {
            addCriterion("priceOfcommission is not null");
            return (Criteria) this;
        }

        public Criteria andPriceofcommissionEqualTo(Integer value) {
            addCriterion("priceOfcommission =", value, "priceofcommission");
            return (Criteria) this;
        }

        public Criteria andPriceofcommissionNotEqualTo(Integer value) {
            addCriterion("priceOfcommission <>", value, "priceofcommission");
            return (Criteria) this;
        }

        public Criteria andPriceofcommissionGreaterThan(Integer value) {
            addCriterion("priceOfcommission >", value, "priceofcommission");
            return (Criteria) this;
        }

        public Criteria andPriceofcommissionGreaterThanOrEqualTo(Integer value) {
            addCriterion("priceOfcommission >=", value, "priceofcommission");
            return (Criteria) this;
        }

        public Criteria andPriceofcommissionLessThan(Integer value) {
            addCriterion("priceOfcommission <", value, "priceofcommission");
            return (Criteria) this;
        }

        public Criteria andPriceofcommissionLessThanOrEqualTo(Integer value) {
            addCriterion("priceOfcommission <=", value, "priceofcommission");
            return (Criteria) this;
        }

        public Criteria andPriceofcommissionIn(List<Integer> values) {
            addCriterion("priceOfcommission in", values, "priceofcommission");
            return (Criteria) this;
        }

        public Criteria andPriceofcommissionNotIn(List<Integer> values) {
            addCriterion("priceOfcommission not in", values, "priceofcommission");
            return (Criteria) this;
        }

        public Criteria andPriceofcommissionBetween(Integer value1, Integer value2) {
            addCriterion("priceOfcommission between", value1, value2, "priceofcommission");
            return (Criteria) this;
        }

        public Criteria andPriceofcommissionNotBetween(Integer value1, Integer value2) {
            addCriterion("priceOfcommission not between", value1, value2, "priceofcommission");
            return (Criteria) this;
        }

        public Criteria andSubtimeIsNull() {
            addCriterion("subtime is null");
            return (Criteria) this;
        }

        public Criteria andSubtimeIsNotNull() {
            addCriterion("subtime is not null");
            return (Criteria) this;
        }

        public Criteria andSubtimeEqualTo(Date value) {
            addCriterion("subtime =", value, "subtime");
            return (Criteria) this;
        }

        public Criteria andSubtimeNotEqualTo(Date value) {
            addCriterion("subtime <>", value, "subtime");
            return (Criteria) this;
        }

        public Criteria andSubtimeGreaterThan(Date value) {
            addCriterion("subtime >", value, "subtime");
            return (Criteria) this;
        }

        public Criteria andSubtimeGreaterThanOrEqualTo(Date value) {
            addCriterion("subtime >=", value, "subtime");
            return (Criteria) this;
        }

        public Criteria andSubtimeLessThan(Date value) {
            addCriterion("subtime <", value, "subtime");
            return (Criteria) this;
        }

        public Criteria andSubtimeLessThanOrEqualTo(Date value) {
            addCriterion("subtime <=", value, "subtime");
            return (Criteria) this;
        }

        public Criteria andSubtimeIn(List<Date> values) {
            addCriterion("subtime in", values, "subtime");
            return (Criteria) this;
        }

        public Criteria andSubtimeNotIn(List<Date> values) {
            addCriterion("subtime not in", values, "subtime");
            return (Criteria) this;
        }

        public Criteria andSubtimeBetween(Date value1, Date value2) {
            addCriterion("subtime between", value1, value2, "subtime");
            return (Criteria) this;
        }

        public Criteria andSubtimeNotBetween(Date value1, Date value2) {
            addCriterion("subtime not between", value1, value2, "subtime");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {
        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}